####################################################
# Blah Software Code      |    Software Version: 3 #
####################################################
#       Software: e-blah!                          #
# Copyrighted  2001-2003 e-blah!                  #
# All Rights Reserved                              #
####################################################

require("$language/BoardLock.lng");

sub MainLO {
	if($URL{'v'} eq 'shownews') { return; }
	if(-e "$root/Maintance.lock") { require("$root/Maintance.lock"); }
	if($URL{'id'} ne '' && $URL{'v'} eq 'invite') { require("$code/Invite.pl"); &LinkMeUp; }
	$gdisable = 1;
	if($maintance && $settings[4] ne 'Administrator') { &Maintain; }
	if($lockout) {
		fopen(FILE,"$members/$username.lo");
		@lock = <FILE>;
		fclose(FILE);
		chomp @lock;
		if($lock[0] eq 'ALLOW') { 1; }
		elsif($lock[0] eq 'TEMP') {
			($for,$long) = split(/\|/,$lock[1]);
			$time = $for*60;
			$maxtime = $long+$time;
			$thistime = time;
			$allowed = $maxtime-$thistime;
			if($allowed > 0) { 1; }
			elsif($URL{'v'} ne 'login' && $URL{'p'} != 2) { &LockOut; }
		}
		elsif($URL{'v'} eq 'login' && $URL{'p'} == 2) { return; }
		else { &LockOut; }
	}
	elsif($noguest && ($username eq 'Guest' || $settings[1] eq '')) { &KickGuest; }
		else { return; }
}

sub Password {
	if($username eq 'Guest') { &error($boardlock[1]); }
	if($settings[4] eq 'Administrator') { return; } # Admin has full access
	&is_member;
	if($Blah{"$URL{'b'}_pw"} eq $binfo[6]) { return; }
	elsif($sidinuse) {
		@boardaccess = split("/",$baccess);
		foreach(@boardaccess) {
			($board,$pass) = split("=",$_);
			if($board eq $URL{'b'} && $pass eq $binfo[6]) { return; }
		}
	}
	$password = crypt($FORM{'pw'},$pwcry);
	$password =~ s/\///g;
	if($settings[26]) { require("$theme/$settings[26].v1"); }
	if($password eq $binfo[6]) {
		# SIDs: Skip the cookies and add a password handle.
		if($sidinuse) {
			fopen(FILE,"$prefs/Sids.sid");
			@sidlist = <FILE>;
			fclose(FILE);
			chomp @sidlist;
			fopen(FILE,"+>$prefs/Sids.sid");
			foreach(@sidlist) {
				($tsid,$ip,$username,$tpw,$endtime,$baccess) = split(/\|/,$_);
				if($URL{'sid'} eq $tsid) {
					if($baccess) { $baccess .= "/"; }
					print FILE "$tsid|$ip|$username|$tpw|$endtime|$baccess$URL{'b'}=$password\n";
				} else { print FILE "$_\n"; }
			}
			fclose(FILE);
		} else { print qq~Set-Cookie: $URL{'b'}_pw=$password; path=/; expires=Thur, 31-Dec-2099 00:00:00 GMT;\n~; }
		return;
	}
	elsif($FORM{'pw'}) { $in = qq~<br><b> $boardlock[2]</b>~; }
	$title = $boardlock[3];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" align=center width="450">
 <tr><form action="$scripturl,v=mindex" method="POST">
  <td bgcolor="$color{'titlebg'}"><font size=2><b><img src="$images/keys.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size=1>$boardlock[4]$in</font></td>
 </tr><tr>
  <td bgcolor="$color{'win2'}">
   <table cellpadding=2 cellspacing=0 width="100%">
    <tr>
     <td align="right" valign="top"><font size=2><b>$boardlock[5]:</b></font></td>
     <td><font size="2"><b>$binfo[2]</b><font size="1"><br>$binfo[0]</font></font></td>
    </tr><tr>
     <td align="right" width="40%"><font size=2><b>$boardlock[6]:</b></font></td>
     <td width="60%"><input type="password" name="pw" size="25"></td>
    </tr>
   </table>
  </td>
 </tr><tr>
  <td bgcolor="$color{'win'}" align="center"><input type="submit" value=" $gtxt{'26'} "></td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}

sub KickGuest {
	if($URL{'v'} eq 'login') { require "$code/Login.pl"; &Login; }
	if($URL{'v'} eq 'register') { require "$code/Register.pl"; &Register; }
	$title = $mbname;
	&header;
	if($creg != 1) { $register = "\n  <br>  <a href=$surl,v=register>$boardlock[7]</a>"; }
	if($username eq 'Guest') { $access = qq~$boardlock[35]<br><font size="1">  <a href="$surl,v=login">$boardlock[8]</a>$register</b></font></font>~; }
		else { $access = $boardlock[9]; }
	print <<"EOT";
<table bgcolor="$color{'border'}" cellspacing="1" cellpadding="4" width="500" align="center">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/ban.gif"> $boardlock[10]</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="2">$access</font></center></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}

sub Maintain {
	if($URL{'v'} eq 'login' && $URL{'p'} == 2) { return; }

	$title = "$mbname $boardlock[11]";
	&header;
	print <<"EOT";
$error
<table bgcolor=$color{'border'} cellpadding=4 cellspacing=1 width="100%" align=center>
 <tr>
  <td bgcolor="$color{'titlebg'}" colspan=2><font size=2><b><img src="$images/ban.gif"> $title</font></b></td>
 </tr><tr>
  <td bgcolor="$color{'win'}" colspan="2"><font size="2">$boardlock[12]<blockquote>$maintancer</blockquote></font></td>
 </tr><tr>
  <td bgcolor=$color{'titlebg'} colspan=2><font size="2"><b><img src="$images/login_sm.gif"> $boardlock[13] $boardlock[8]</b></font></td>
 </tr><tr><form action="$scripturl,v=login,p=2" method="POST">
  <td bgcolor="$color{'win'}">
   <table cellpadding=3 width=100%>
    <tr>
     <td align=right width=25%><font size=2><b>$boardlock[15]:</b></font></td>
     <td width=25%><input type=text name=username size=20></td>
     <td align=right><font size=2><b>$boardlock[16]:</b></font></td>
     <td><input type="checkbox" name="nocookie" value="1"></td>
    </tr><tr>
     <td align=right><font size=2><b>$boardlock[6]:</b></font></td>
     <td><input type="password" name=password size=20></td>
     <td align=right><font size=2><b>$boardlock[18]:</b></font></td>
     <td><select name="days">
      <option value=".5">12 $gtxt{'3'}</option>
      <option value="1">1 $boardlock[19]</option>
      <option value="4">4 $boardlock[19]</option>
      <option value="7">1 $gtxt{'39'}</option>
      <option value="31">1 $gtxt{'40'}</option>
      <option value="forever" selected>$boardlock[21]</option>
     </select>     <input type=submit value="$boardlock[8]">
     </td>
    </tr>
   </table>
  </td>
 </form></tr>
</table>
EOT
	&footer;
	exit;
}

sub LockOut {
	print "Content type: html/text\n\n";
	print <<"EOT";
<html>
<head><title>$mbname $boardlock[23]</title></head>
<body link="#000000" vlink="#000000" alink="#000000" topmargin="6">
<table cellspacing="0" cellpadding="1" width="100%">
 <tr>
  <td align="center" colspan="2"><b><font size="4" face="Verdana">$mbname $boardlock[23]<hr color="#000000" size="1"></font></b></td>
 </tr><tr>
  <td colspan="2"><font size="2" face="Verdana"><br>$boardlock[24]<br><br>$boardlock[25]<br><br></font></td>
 </tr><tr><form action="$scripturl,v=login,p=2" method="POST">
  <td align="right" width="50%"><font size="2" face="Verdana"><b>$boardlock[15]:  </b></font></td>
  <td width="50%"><input type="text" name="username" size="25" value="$URL{'u'}"></td>
 </tr><tr>
  <td align="right" width="50%"><font size="2" face="Verdana"><b>$boardlock[6]:  </b></font></td>
  <td width="50%"><input type="password" name="password" size="20" value="$URL{'p'}"></td>
 </tr><tr>
  <td colspan="2" align="center"><input type=submit value="$boardlock[8]"></td>
 </tr><tr>
  <td colspan="2" align="center"><br><hr color="#000000" size="1"><font size="1" face="Verdana"><br><br><br><br>$mbname $boardlock[23]<br>$copyright</font></td>
 </tr>
</table>
</body>
</html>
EOT
	exit;
}

sub Banned {
	$gdisable = 1;
	($banlimit,$bantime) = @_;
	@settings = ();
	if($banlimit && time < $bantime) { $timelimit = qq~<hr size="1" color="$color{'border'}"><b>$boardlock[30] $banlimit $boardlock[19]. $boardlock[32] ~.get_date($bantime).'.</b>'; }
	elsif($banlimit && time > $bantime) { # Unban this user, his banning is completed ...
		fopen(FILE,">$prefs/BanList.txt");
		foreach(@banlist) {
			($ipaddy,$banlimit,$bantime) = split(/\|/,$_);
   			$length = length($ipaddy);
   			$ipsearch = substr($ENV{'REMOTE_ADDR'},0,$length);
			if($ipsearch =~ /\Q$ipaddy/i || $username eq $ipaddy) { next; }
			print FILE "$_\n";
		}
		fclose(FILE);
		return;
	}
	$time = time;
	fopen(FILE,"+>>$prefs/NoAccess.txt");
	print FILE "$username|$ENV{'REMOTE_ADDR'}|$time\n";
	fclose(FILE);
	$username = 'Guest'; # Reset to guest
	$title = $boardlock[33];
	&header;
	print <<"EOT";
<table bgcolor="$color{'border'}" cellpadding="4" cellspacing="1" align="center" width="600">
 <tr>
  <td bgcolor="$color{'titlebg'}"><font size="2"><b><img src="$images/ban.gif"> $title</b></font></td>
 </tr><tr>
  <td bgcolor="$color{'win'}"><font size="2">$boardlock[34]$timelimit</font></td>
 </tr>
</table>
EOT
	&footer;
	exit;
}
1;